// **********************************************************************************
//
//  アクション自動ルックアップ
//
//  履歴
//    2022.03.18    新規作成(松本)
//    2022.08.24    レコード再利用の場合コピーしないように
//
//                                                   Copyright(C)2022 Caminova, Inc.
// **********************************************************************************
(function (PLUGIN_ID) {
    "use strict";
    // **********************************************************************************
    //   アクション自動ルックアップ
    // **********************************************************************************
    kintone.events.on(['app.record.create.show'], async function (event) {
        if(event.reuse){
            return event;
        }
        const resp = await kintone.api(kintone.api.url('/k/v1/app/form/fields.json', true), 'GET', {
            "app": kintone.app.getId()
        });
        var lookupfield = [];
        var tablelookupfield = [];
        console.log(Object.values(resp.properties))
        for (var x = 0; x < Object.values(resp.properties).length; x++) {
            if ("lookup" in Object.values(resp.properties)[x]) {
                console.log(Object.values(resp.properties)[x])
                lookupfield.push(Object.values(resp.properties)[x].code);
            }
            if(Object.values(resp.properties)[x].type === "SUBTABLE"){
                console.log(Object.values(Object.values(resp.properties)[x].fields));
                for(var y = 0; y < Object.values(Object.values(resp.properties)[x].fields).length; y++){
                    if ("lookup" in Object.values(Object.values(resp.properties)[x].fields)[y]) {
                        console.log(Object.values(Object.values(resp.properties)[x].fields)[y])
                        tablelookupfield.push({
                            "table": Object.values(resp.properties)[x].code,
                            "field": Object.values(Object.values(resp.properties)[x].fields)[y].code
                        });
                    }
                }
            }
        }
        
        console.log("lookup")
        console.log(lookupfield);
        console.log(tablelookupfield);
        for(var x = 0; x < lookupfield.length; x++){
            if (event.record[lookupfield[x]].value != undefined) {
                event.record[lookupfield[x]].lookup = true;
            }
        }
        for(var x = 0; x < tablelookupfield.length; x++){
            var tablefield = event.record[tablelookupfield[x].table].value;
            for(var y = 0; y < tablefield.length; y++){
                if (tablefield[y].value[tablelookupfield[x].field].value != undefined) {
                    tablefield[y].value[tablelookupfield[x].field].lookup = true;
                }
            }
        }
        return event;
    });
})(kintone.$PLUGIN_ID);
