// jQuery.noConflict();
(function(PLUGIN_ID) {
  'use strict';
    // ここのコードはご自身で作成したコードに変更してください
  var AUTH_CODE = 'caminova_actionautolookup';

  var config = kintone.plugin.app.getConfig(PLUGIN_ID);
  // var editable = new ImageEditable(PLUGIN_ID, $config);
  //var AUTH_CODE = config.licensekey;
　/*
  var simulator = new Simulator(Object.assign(
    { pluginId: PLUGIN_ID },
    $config,
    { pluginConfig: config }
  ));
  */
  kintone.events.on(['app.record.index.show', 'app.record.detail.show'], function (e) {
    // 認証情報キー
    var akey = 'caminova_actionautolookup_key';
    // 当日
    var dt = new Date ();
    var todayStr = dt.getFullYear() + ("00" + (dt.getMonth()+1)).slice(-2) + ("00" + dt.getDate()).slice(-2);
    //console.log('akey:' + akey + ' todayStr:' + todayStr);
    // クッキーから実行可否を取り出します
    var ckea = getCookieArray();
    //console.log(ckea);
    // クッキー保存情報使う？
    var useCookie = false;
    // 指定キーのクッキーあり？
    if (ckea && ckea[akey]) {
      var ckestore = JSON.parse(ckea[akey]);
      // 当日？
      if ((ckestore.today) && (todayStr == ckestore.today)) {
        useCookie = true;
      }
    }
    if (useCookie) {
      // 日付情報が当日なら保持している情報を使う
      processUM(e, ckestore.resp);
    }
    else {
      // cookieがないか、当日でないなら問い合わせる
      callUserManagement(AUTH_CODE).then(function(resp) {
        // 問い合わせ結果をcookieへ
        var cookieSave = { today: todayStr, resp: resp};
        var cookieStr = akey + '=' + JSON.stringify(cookieSave);
        document.cookie = cookieStr;
        //console.log('coockie:' + cookieStr);
        // 問い合わせ結果の処理
        processUM (e, resp);
      });
    }
    return e;
  });
  function processUM(e, resp) {
      // 実行可？
      var runOk = false;
      let section = document.createElement("div");
      // resp.result　には、OK か NG か ERROR が入ります
      if ((resp.result == 'OK') || (resp.result == 'ERROR')) {
        // pass!!
        // サンプルですのでアラート表示だけですが、セッションやクッキーに保存すると
        // 認証回数が削減でき動作も速くなると思います。
          if (resp.result == 'ERROR') {
            // エラー時は何も言わずに通す
          }
          else if (resp.step == '試用開始'){
            // 初回起動時
            section.innerHTML = resp.firstmessage + '<br /><br /><a href="' + resp.orderurl + '">お申込み・お問合せはこちら</a>';
            swal({
              title: 'フィールド非表示プラグイン',
              content: section,
              icon: 'success',
              button: 'OK'
            });
          }
          else if (resp.ordertype != '購入済'){
            // 未購入（＝試用中）
            section.innerHTML = '試用期間　' + resp.message + '<br /><br /><a href="' + resp.orderurl + '">お申込み・お問合せはこちら</a>';
            swal({
              title: 'フィールド非表示プラグイン',
              content: section,
              icon: 'info',
              button: 'OK'
            });
          }
          else if (resp.message != ''){
            // 残日数わずか
            section.innerHTML = resp.message + '<br /><br /><a href="' + resp.orderurl + '">お申込み・お問合せはこちら</a>';
            swal({
              title: 'フィールド非表示プラグイン',
              content: section,
              icon: 'warning',
              button: 'OK'
            });
          }
        // 実行可
        runOk = true;
      }
      else {
        if (resp.result != '') {
          section.innerHTML = resp.message + '<br /><br /><a href="' + resp.orderurl + '">お申込み・お問合せはこちら</a>';
          swal({
            title: 'フィールド非表示プラグイン',
            content: section,
            icon: 'error',
            button: 'OK'
          });
        }
        else {
          swal({
            title: 'フィールド非表示プラグイン',
            text: 'エラー',
            icon: 'error',
            button: 'OK'
          });
        }
      }
      // 詳細画面表示
      /*
      if ('app.record.detail.show' == e.type) {
        simulator.setDevice('pc');
        simulator.runOk(runOk);
        simulator.init(e);
      }
      */
  };

  //kintone.events.on('app.record.detail.show', function(event) {
  //  simulator.setDevice('pc');
  //  simulator.init(event);
  //});

  //kintone.events.on('mobile.app.record.detail.show', function(event) {
  //  simulator.setDevice('mobile');
  //  simulator.init(event);
  //});

  function callUserManagement(key) {
    // 外部URLへリクエストして戻り値を返す
    // 現状は全員共通のURLですが、個別URLにしてスロットリング設定も考えています。
    var url =
      'https://0du0kck1qk.execute-api.ap-northeast-1.amazonaws.com/prod/auth-management';
    var param = {
      param: {
        subdomain: getSubdomain(),
        pluginkey: key,
        appid: kintone.app.getId(),
        mode: '1',
      },
    };
    // kintone.proxyで呼び出します。
    return kintone.proxy(url, 'POST', {}, param).then(
      function (args) {
        //success
        /*  args[0] -> body(文字列)
         *  args[1] -> status(数値)
         *  args[2] -> headers(オブジェクト)
         */
        var status = args[1];
        var json_body = JSON.parse(args[0]);
        if (status === 200) {
          // 正常終了時はそのままレスポンスを返します
          return json_body;
        } else {
          // 200以外は ERROR で返しますが、サーバー障害の可能性があるので認証通した方が良いと思います
          return {
            result: 'ERROR',
            message: `status:${status} body:${JSON.stringify(json_body)}`,
          };
        }
      },
      function (error) {
        // error の場合は、レスポンスボディ(文字列)を返します（ほぼ発生しないと思いますが。。。）
        return {
          result: 'ERROR',
          message: `error:${error}`,
        };
      }
    );
  }

  function getSubdomain() {
    var subdomain = kintone.api.url('/k/v1/records');
    return subdomain.slice(subdomain.indexOf('/') + 2, subdomain.indexOf('.'));
  }

  function getCookieArray(){
    var arr = new Array();
    if(document.cookie != ''){
      var tmp = document.cookie.split('; ');
      for(var i=0;i<tmp.length;i++){
        var data = tmp[i].split('=');
        arr[data[0]] = decodeURIComponent(data[1]);
      }
    }
    return arr;
  }
})(kintone.$PLUGIN_ID);

